# Copyright:
# ----------------------------------------------------------------------------
# This confidential and proprietary software may be used only as authorized
# by a licensing agreement from ARM Limited.
#      (C) COPYRIGHT 2018 ARM Limited, ALL RIGHTS RESERVED
# The entire notice above must be reproduced on all authorized copies and
# copies may only be made to the extent permitted by a licensing agreement
# from ARM Limited.
# ----------------------------------------------------------------------------
#

import tools_checker
from config_system import get_config

def plugin_exec():
    compiler = ""

    #Only check compiler if host explore is enabled
    if get_config('ALLOW_HOST_EXPLORE')['value'] == 'y':
        gnu = get_config('TOOLCHAIN_GNU')['value']
        if gnu == "y":
            prefix = get_config('TOOLCHAIN_PREFIX')['value']
            compiler = prefix + "gcc"
        else:
            compiler = "clang"

    tools_checker.check_tools_versions( compiler )
